----------------------------------------------------------------------------------
-- Ksztette: Pap Csaba (NPIRWP)
-- A feladat:
--Kezdetben kt szegmens vilgt a jobb szls 7-szegmenses kijelzn.
--A 0-s s az 1-es nyomgomb megnyomsval lehet lptetni a kt szegmenst az ramutat
--jrsval megegyez ill. ellenkez irnyban krbe-krbe (csak a kijelz szls
--szegmenseit kell hasznlni, a g szegmenst soha).
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Hazi_feladat_potzh is
    Port ( reset : in  STD_LOGIC; -- aszinkron reset
           clk : in  STD_LOGIC;  -- rajel
           gomb : in  STD_LOGIC_VECTOR (1 downto 0); --gombok. gomb(0) jobbra; --gomb(1) balra; (button0, s button1) 
           hasznalt_segment : out  STD_LOGIC_VECTOR (5 downto 0); -- a hasznlt szegmensek
           nem_hasznalt_seg : out  STD_LOGIC_VECTOR (1 downto 0); -- a nem hasznlt szegmensek (g,dp)
           digit : out  STD_LOGIC_VECTOR (3 downto 0)); -- kijelzk
end Hazi_feladat_potzh;

architecture Behavioral of Hazi_feladat_potzh is
signal hasznalt_seg_local: STD_LOGIC_VECTOR (5 downto 0); --tmeneti vltoz a processen bellre

begin

digit<="1110"; --csak a jobbszls led vilgtson
nem_hasznalt_seg<="11"; -- a nem hasznlt szegmensek ne vilgtsanak

process (clk, reset, gomb, hasznalt_seg_local)
begin

	if reset='1' then hasznalt_seg_local<="111100";  --ha megvan nyomva a reset a kt jobb szls szegmens vilgtson
	else if clk'event and clk='1' then   --amennyiben felfut rajel van
				if (gomb(0)='1') then hasznalt_seg_local<=hasznalt_seg_local(4 downto 0) & hasznalt_seg_local(5); --forgats balra
				else if (gomb(1)='1') then hasznalt_seg_local<=hasznalt_seg_local(0) & hasznalt_seg_local(5 downto 1); -- forgats jobbra
						else hasznalt_seg_local<=hasznalt_seg_local; --ha semmi sem trtnt, akkor legyen az elz
					  end if;
				end if;
			end if;
	end if;		
			
	hasznalt_segment<=hasznalt_seg_local; --j rtk belltsa
	
end process;

end Behavioral;

