-- Ksztette : Molnr Sndor 2008.10.08
-- egy dekdos hexa kijelz villogtatva

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity dekad_kij is
    Port (clk50: in std_logic;
	       rst:in std_logic;
			 tobbi_led:out std_logic_vector(7 downto 0);
	       d : in std_logic_vector(3 downto 0) ;-- megjelentend szam: 0..F
          digit : out std_logic_vector(3 downto 0); -- digit engedlyezs aktv '0'
	       seg : out std_logic_vector(7 downto 0); -- szegmens meghajts aktv '0'
			 villogo_s: in std_logic_vector(2 downto 0)
		);
end dekad_kij;

architecture Behavioral of dekad_kij is
 signal hertz_count: std_logic_vector(31 downto 0); --mhz oszt
 signal masodperc: std_logic:='1';
 signal vill_seg: std_logic_vector(7 downto 0);
begin
 tobbi_led<=(others=>'0');  --Ez kikapcsolja a nem hasznlatos ledeket
 
 process(clk50,rst)  --rzkenysgi lista
 begin
   if rst='1' then  --alaphelyzetbe lltja a vltozkat
	  hertz_count <=(others=>'0');
	  masodperc<='0';
	elsif clk50'event and clk50='1' then  --f rajel felfut le van
	  hertz_count<=hertz_count+1;
	  
	  if hertz_count = 50000000-1 then  --ha elrte az 1 msodpercet, 50 hz-nl 50M-1
	    masodperc<=not masodperc;
		 hertz_count<=(others=>'0');
	  end if;
	end if;
  
  case villogo_s is
	 when "000" =>  vill_seg <=      masodperc & "0000000";
	 when "001" =>  vill_seg <= "0" & masodperc & "000000";
	 when "010" =>  vill_seg <= "00" & masodperc & "00000";
	 when "011" =>  vill_seg <= "000" & masodperc & "0000";
	 when "100" =>  vill_seg <= "0000" & masodperc & "000";
	 when "101" =>  vill_seg <= "00000" & masodperc & "00";
	 when "110" =>  vill_seg <= "000000" & masodperc & "0";
	 when others => vill_seg <= "0000000" & masodperc;
  end case;
 end process; 
 
  digit	 <= "1110";-- csak a jobb szls kijelzt engedlyezem a 4 kzl
  seg <= "00000011" xor vill_seg when d = "0000" else
         "10011111" xor vill_seg when d = "0001" else
         "00100101" xor vill_seg when d = "0010" else
         "00001101" xor vill_seg when d = "0011" else
         "10011001" xor vill_seg when d = "0100" else
         "01001001" xor vill_seg when d = "0101" else
         "01000001" xor vill_seg when d = "0110" else
         "00011111" xor vill_seg when d = "0111" else
         "00000001" xor vill_seg when d = "1000" else
         "00011001" xor vill_seg when d = "1001" else	
			"00010001" xor vill_seg when d = "1010" else	
	      "11000001" xor vill_seg when d = "1011" else   
         "01100011" xor vill_seg when d = "1100" else  
         "10000101" xor vill_seg when d = "1101" else	
         "01100001" xor vill_seg when d = "1110" else  
         "01110001" xor vill_seg  ;			
end Behavioral;