--kapcsols kijelzs
--annak a kapcsolnak a szmt rja ki a balszls kijelzre, amelyik ppen be van kapcsolva
-- ha egynl tbb van bekapcsolva, vagy egy sincs bekapcsolva, akkor vilgtson a kzps szegmens.
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity led_dek_villogtatas is
    Port ( clk50 : in  STD_LOGIC; --50Hz-es rajel
           reset : in  STD_LOGIC;   -- aszinkron reset
           dis : in  STD_LOGIC;  -- disable (tilt) bit
           s : out  STD_LOGIC_VECTOR (6 downto 0); -- szegmens
		   digitek: out STD_LOGIC_VECTOR (3 downto); -- a 4 db kijelz
		   teszt: in STD_LOGIC; --teszt jel
		   k: in STD_LOGIC_VECTOR (7 downto 0); -- a 8 kapcsol
end led_dek_villogtatas;

architecture Behavioral of villog1s is
 signal hertz_count: std_logic_vector(31 downto 0); --mhz oszt
 signal masodperc: std_logic:='1';
 
-- a villogtats process (szmllbl "szrmaztatva")
process (clk50, reset, hertz_count, masodperc)
begin
	if reset='1' then --ha reset van. akkor mindent kinullz
		hertz_count<=(others=>'0');
		masodperc<='0';
	elsif clk50' event and clk50='1' then --ha ppen felfut rajel van
		hertz_count<=hertz_count+1;
		if hertz_count=25e6-1 then
			masodperc<=not masodperc;
			hertz_count<=(others=>'0');
		end if;
	end if;
end process;
-- a kvetkez meglehetsen hossz felttel rja meg azt, hogy :
-- amikor sem a teszt, sem a dis nincs megnyomva, s a kapcsolk kzl egyik sincs bekapcsolva vagy egynl tbb (ezrt kell a not) van bekapcsolva.
digitek<= masodperc & "111" when ((teszt='0') and (dis='0') and ((k="00000000")or (not(k="00000001" or
									k="00000010" or k="00000100" or k="00001000" or k="00010000" 
									or k="00100000" or "01000000" or k="10000000"))))
						else
						"0000" when teszt='1' else "0111"; --"0000" mindenkit engedlyezni kell, vagy ha a teszt 1, akkor a balszlst.

-- az albbi rsz adja meg, hogy mi jelenjen meg a kijelzn (mramelyiket vezreljk)
s<="1111111" when dis='1' else		-- ha a tilts 1 akkor egyik szegmens se vilgtson
   "0000000" when teszt='1' else	-- ha teszt be van lve, akkor mindenkinek engedlyezve kell lennie
   "1000000" when k="00000000" else -- ha a egyik kapcsol sincs bekapcsolva, akkor 0-t rjon ki
   "1111001" when k(0)='1' else	    -- ha a jobbszls, akkor rjon ki egy 1-est
   "0100100" when k(1)='1' else		-- ha a jobbszls melletti (jobbrl balra halad a szmozs) akkor rjon ki egy 2-est 
   "0110000" when k(2)='1' else	
   "0011001" when k(3)='1' else
   "0010010" when k(4)='1' else
   "0000010" when k(5)='1' else
   "1111000" when k(6)='1' else
   "0000000" when k(7)='1' else     --ha a balszls, akkor rjon ki egy 8-ast
   "1111111";
  
end Behavioral;


