library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity dekad4_kij is
    Port ( clk50 : in std_logic;
             rst : in std_logic;
       kapcsolok :in std_logic_vector(7 downto 0);
           digit : out std_logic_vector(3 downto 0); 
             seg : out std_logic_vector(6 downto 0) 
		   );
end dekad4_kij;

architecture Behavioral of dekad4_kij is
constant teszt1ms : std_logic_vector(31 downto 0):=conv_std_logic_vector(50000,32);

signal curr	: std_logic_vector(3 downto 0) ;	
signal frissit_szlo :  std_logic_vector(31 downto 0) ;                                              
signal cd		: std_logic_vector(1 downto 0) ;	
signal bcdint : std_logic_vector(15 downto 0) ;

begin

bcdint <= "00" & kapcsolok(7 downto 6) & "00" & kapcsolok(5 downto 4) & 
          "00" & kapcsolok(3 downto 2) & "00" & kapcsolok(1 downto 0) ;
			 
process (clk50, rst, cd, frissit_szlo)
begin
if rst = '1' then	
	cd <= (others => '0') ;	 
	frissit_szlo <= (others => '0') ; 
elsif clk50'event and clk50 = '1' then
   frissit_szlo <= frissit_szlo + 1 ;
	
	if frissit_szlo = teszt1ms-1 then 
	   frissit_szlo <= (others => '0') ; 
		cd <= cd + 1 ; 
	end if ;	
	
end if ;

end process ;

 curr <= bcdint(3 downto 0)  when cd = "00" else
         bcdint(7 downto 4)  when cd = "01" else
         bcdint(11 downto 8) when cd = "10" else
			bcdint(15 downto 12) ;
			
 digit <= "1111"  when rst = '1'  else
          "1110"	when cd 	= "00" else	
			 "1101"	when cd 	= "01" else	
			 "1011"	when cd 	= "10" else	
			 "0111" ;
			 
 seg 	<= "1111111"  when rst = '1'     else
         "1000000"  when curr = "0000" else
         "1111001"  when curr = "0001" else
         "0100100"  when curr = "0010" else
         "0110000"  ;
 
end Behavioral;