library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity led_villogtatas is
    Port ( clk50 : in std_logic;
           rst : in std_logic;
			  led : out std_logic
			  );
end led_villogtatas;

architecture Behavioral of led_villogtatas is
 signal hertz_count	: std_logic_vector(31 downto 0) ;	
 signal masodperc     : std_logic := '1'; 

begin

process (clk50, rst,hertz_count, masodperc )
begin
if rst = '1' then
	hertz_count <= (others => '0') ;	
	masodperc  <= '0' ;
elsif clk50'event and clk50 = '1' then 
	hertz_count <= hertz_count + 1 ;	 

	if hertz_count = 5e7 - 1 then  
		masodperc <= not masodperc	;
		hertz_count <= (others => '0') ;
	end if ;

end if ;
   

end process ;	

 led <= masodperc;
 
end Behavioral;
