-- Ksztette : Vgh Tams 2006.11.15.
-- 
--Tervezzen egy egyszer szmll ramkrt, amely egy nyomgomb (BTN0) 
--megnyomsnak hatsra nvel egy 4 bites szmot.  
--A nyomgomb megnyomsi idejt mrni kell (min. 500 ms) s prellmentesteni kell.

--Ez vgzi a nyomgomb jelnek zavarmentestst (prellmentests) 
--s ellltja a gomb-megnyomsa ill. elengedse esemnyjelzst 
--(0: nincs esemny,1:megnyoms,2:elengeds kdja)

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity prellment is
    Port ( gomb  : in std_logic; -- nyomgomb
           clk50 : in std_logic; -- 50 MHz-es f szinkronizl rajel
           rst : in std_logic;   -- aszinkron trls
           x20msen : in std_logic; -- prellmentests mintavtel engedlyez bemenet
           gomb_esemeny : out std_logic_vector(1 downto 0));	-- gombnyoms esemny trtnt jelzse kimenet
end prellment;

architecture Behavioral of prellment is
    signal fifo : std_logic_vector(1 downto 0) ;--FIFO regiszter a nyomgombhoz 

begin
process (clk50, rst)

begin
 if rst = '1' 
    then
	   fifo <= (others => '0') ;	--resetben vagyok, ezrt a szlo minden bitje 0
	   gomb_esemeny <= (others => '0') ; -- nincs esemny jelzs
	 elsif clk50'event and clk50 = '1' 
         then -- f rajel felfut le esemny
               if x20msen = '1' --mintavtelezs parancs rkezett 
					     then 
	                 --prellmentests mintavteli idpontja : 20 ms-onknt
                      fifo <= fifo(0) &  gomb ;--gombnyomst belptetem (mintavtelezem)
                      gomb_esemeny(0) <= (fifo(1) xor fifo(0)) and fifo(0) ;--megnyoms esemny trtnt
			             gomb_esemeny(1) <= (fifo(1) xor fifo(0)) and (not fifo(0)) ;--elengeds esemny trtnt
                    else
				          gomb_esemeny <= (others => '0') ; -- gomb esemny jelzs vge
				          					
               end if;

   	
 end if ;

end process ;

end Behavioral;
