----------------------------------------------------------------------------------
--Ksztette: Molnr Sndor
--Ez a modul msodpercenknt villogtat egy ledet
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity villog1s is
    Port ( clk50 : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           led : out  STD_LOGIC;
           tobbi_led : out  STD_LOGIC_VECTOR (6 downto 0));
end villog1s;

architecture Behavioral of villog1s is
 signal hertz_count: std_logic_vector(31 downto 0); --mhz oszt
 signal masodperc: std_logic:='1';
begin
 tobbi_led<=(others=>'0');  --Ez kikapcsolja a nem hasznlatos ledeket

 process(clk50,rst)  --rzkenysgi lista
 begin
   if rst='1' then  --alaphelyzetbe lltja a vltozkat
	  hertz_count <=(others=>'0');
	  led<='0';
	  masodperc<='0';
	elsif clk50'event and clk50='1' then  --f rajel felfut le van
	  hertz_count<=hertz_count+1;
	  
	  if hertz_count = 50000000-1 then  --ha elrte az 1 msodpercet, 50 hz-nl 50M-1
	    masodperc<=not masodperc;
		 hertz_count<=(others=>'0');
	  end if;
	end if;
	led<=masodperc;  --nincs rajellel szinkronizlva, mindig lefut, bels vltoz tartalmt kijuttatja
 end process;
end Behavioral;

