-- Ksztette : Vgh Tams 2006.11.15.
-- 
--Tervezzen egy egyszer szmll ramkrt, amely egy nyomgomb (BTN0) 
--megnyomsnak hatsra nvel egy 4 bites szmot.  
--A nyomgomb megnyomsi idejt mrni kell (min. 500 ms) s prellmentesteni kell.

--A prell azt jelenti, hogy a nyomgomb (mechanikus kontaktus) megnyomsakor ill.
--elengedsekor zavar impulzusok keletkeznek, mieltt stabilizldna a jel.
--Ennek a zavar impulzus csomagnak a hossza kisebb 20ms-nl egy mikrokapcsolnl.
--A nyomgomb jele min. 40..100 ms hossz.  

--Ez a vltozat egyetlen VHDL modulbl ll, ami tartalmazza ugyanazt a strukturlt
--tervet, amit a demo_a s a demo_b.

--Ez a vltozat is a rendszerterv (blokksma) alapjn kszl, ppgy mint a demo_a s a demo_b
--vltozat. 

--Ennek a mdszernek ugyanaz az elnye, mint a rajzolt blokksms vltozatnak, azaz
--a terv strukturlt, de a modulok nem tesztelhetk egymstl fggetlenl!!!!

--Egy bonyolult strukturlt terv brmely modulja lehet ilyen felpts,azaz  
--egy modulban hasznlhatunk tbb processzt s ms konkurrens utastst.

--Ez a vltozat biztostja a legjobban a terv hordozhatsgt, mivel egyetlen VHDL-bl ll.



library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity gombdetektor is
	port ( clk50     : in    std_logic; --50MHz-es f rajel
         -- nyomogomb : in    std_logic; --BTN0-s nyomgomb
          rst       : in    std_logic; --aszinkron trls
          digit     : out   std_logic_vector (3 downto 0);--htszegmense kijelz digit eng. 
         -- led       : out   std_logic; --LED0
          seg       : out   std_logic_vector (6downto 0);--htszegmense kijelz segmens vezrls 
			 gomb		  : in 	 std_logic_vector (3 downto 0));
			 
	  TYPE allapotok IS (megnyomasra_var,elengedesre_var);-- az FSM llapotai		 
			 
end gombdetektor;

architecture Behavioral of gombdetektor is
  -- signal d          : std_logic_vector (3 downto 0);--hexa szamll, htszegmenses kijelzs
   signal x20ms_out  : std_logic;--20ms-os mintavteli id jelzse
--   signal gomb_esemeny    : std_logic_vector (3 downto 0);-- gombnyoms esemny jelzse 
	
	signal x20ms_count	: std_logic_vector(31 downto 0) ;	-- prellmentest oszt
	
	--signal fifo : std_logic_vector(7 downto 0) ;--FIFO regiszter a nyomgombhoz 
	
	--signal stopper : std_logic_vector(31 downto 0);-- real time ra gombnyoms idhz
 --  signal allapot: allapotok; -- automata (FSM) llapotvltozja
	signal melyik:std_logic_vector(1 downto 0);
begin



--begin dekad_kij komponens
digit	 <= "1110";-- csak a jobb szls kijelzt engedlyezem a 4 kzl
  seg <= "1111001" when melyik = "00" else--1
         "0100100" when melyik = "01" else--2
         "0110000" when melyik = "10" else--3
         "0011001" when melyik = "11" else
			"1111111";



--begin oszto_20ms komponens
process (clk50, rst)
begin
if rst = '1' then
     x20ms_count <= (others => '0') ;	
	  x20ms_out <= '0' ;	-- 

elsif clk50'event and clk50 = '1' then -- f rajel felfut le 
	x20ms_count <= x20ms_count + 1 ;	 --ketyeg az ra

	if x20ms_count = 1000000-1 then  -- 50 MHz-et kell leosztani  20 ms-ra
		x20ms_out <= '1' ;	--20ms-os kimenetet aktivlom (1 rajel ideig fog csak tartani!)
		x20ms_count <= (others => '0') ;
	else 
		x20ms_out <= '0' ; 
		  --csak 1 rajel ideig tarthat a kiadott parancs (ez most 1 bites parancs!)
	end if ;


end if ;
end process ;
--end oszto_20ms komponens


--begin prellment komponens
process (clk50, rst)

begin
 if rst = '1'     then
		melyik<="00";
		 elsif clk50'event and clk50 = '1' 
         then -- f rajel felfut le esemny
               if x20ms_out = '1' --mintavtelezs parancs rkezett 
					     then 
							if gomb="0001" then melyik<="00";
													elsif gomb="0010" then melyik<="01";
													elsif gomb="0100" then melyik<="10";
													elsif gomb="1000" then melyik<="11";
													end if;
					end if;

   	
 end if ;

end process ;





end Behavioral;

